import React, {useState} from 'react';
import {of as observableOf} from 'rxjs';
import { UserContext } from "../../../src/client/hooks/UserContext";

export const mockedUser = {
  id: 123,
  avatar: null,
  nickName: 'John Doe',
  userAccount: {
    username: 'johndoe@ddf.fr',
    isAdmin: false,
    isOperator: false,
    isContributor: true
  },
  place: {
    id: 123,
    name: 'Paris',
    countryCode: 'FR',
    countryId: '123',
    countryName: 'France',
    stateName: 'Île-de-France'
  }
};

/**
 * generate UserContext mock 
 */
export function UserContextMock({loggedIn = false,children, ...props} = {}) {
  const _user = loggedIn ? {isLogged: true, user: mockedUser} : {isLogged: false, user: null};
  const [user, setUser] = useState(_user);
  return (<UserContext.Provider value={{ user, setUser }}>
    {children}
    </UserContext.Provider>)
}


/**
 *
 * Mocked service description : 
 *
 * {
 *    // Gives an observable which always resolves to the default value. In logged in mode, it will return 
 *    // a logged in default user : 
 *    //    
 *    //   { 
 *    //     isLogged: true,
 *    //     user: <userMock>
 *    //   }
 *    // 
 *    // In logged out mode it will return the object : 
 *    //
 *    //   {
 *    //     isLogged: false,
 *    //     user: null
 *    //   }
 *    currentUser() => Observable,
 *
 *    // React hook. In logged in mode, will return {isLogged: true, user: <userMock>}, in logged out mode it will return
 *    // {isLogged: false, user: null}
 *    useLoggedUser() => Object
 * }
 *
 * In cases in which a default user object must be returned, the following mock is used : 
 *
 *
 * userMock = {
 *   id: 123,
 *   avatar: null,
 *   nickName: 'John Doe',
 *   userAccount: {
 *     username: 'johndoe@ddf.fr',
 *     isAdmin: false,
 *     isOperator: false,
 *     isContributor: true
 *   },
 *   place: {
 *     id: 123,
 *     name: 'Paris',
 *     countryCode: 'FR',
 *     countryId: '123',
 *     countryName: 'France',
 *     stateName: 'Île-de-France'
 *   }
 * }
 *
 *
 * @param {Object} options
 * @param {boolean} options.loggedIn Defines the behavior of the provided mock. If true, it will behave with a logged in user.
 * 
 */
export function generateUserAuthenticationServiceMock({loggedIn = false} = {}) {
  let currentUserResult = loggedIn ? {isLogged: true, user: mockedUser} : {isLogged: false, user: null};

  return {
    currentUser: observableOf(currentUserResult),
    useLoggedUser: () => currentUserResult
  }
}

/**
 * Default instance of user authenticatino service mock, if you do not wich to use the generator generateUserAuthenticationServiceMock 
 */
export const userAuthenticationServiceMock = generateUserAuthenticationServiceMock();

/**
 * This function returns the object to use as mock for the whole module UserAuthenticationService.js . To use this way : 
 *
 * jest.mock('../real/path/to/UserAuthenticationService', () => {
 *   return jest.requireActual('../path/to/jest/utilities/servicesMocks/UserAuthenticationServiceMock').generateModuleMock(options)
 * });
 *
 * Note, you need to use jest.mock() in your test suite (and it's not wrapped here) because jest.mock() is preprocessed by
 * babel and isn't actually run where you place it in your code. 
 * 
 * The object uses to mock the module reexports all constants (graphQL queries),
 * but exports a mock in place of getUserAuthenticationService. This mock is generated by the function
 * generateUserAuthenticationServiceMock() which is forwarded the options object given to this function
 */
export function generateModuleMock(options) {
  const ActualService = jest.requireActual('../../../src/client/services/UserAuthenticationService');
  const userAuthenticationServiceMock = generateUserAuthenticationServiceMock(options);
  return {
    getUserAuthenticationService: () => userAuthenticationServiceMock,
    gqlRegisterUserAccountMutation: ActualService.gqlRegisterUserAccountMutation,
    gqlLoginMutation: ActualService.gqlLoginMutation,
    gqlLogoutMutation: ActualService.gqlLogoutMutation,
    gqlMeQuery: ActualService.gqlMeQuery,
    gqlResetUserAccountPasswordMutation: ActualService.gqlResetUserAccountPasswordMutation,
    gqlUnregisterUserAccountMutation: ActualService.gqlUnregisterUserAccountMutation,
    gqlResetUserAccountPasswordByMailMutation: ActualService.gqlResetUserAccountPasswordByMailMutation,
  }
}

